'*******************************************************************************
'* Jalali, (Shamsi, Persian) Date and calendar. (Compatible with AMC8)         *
'* Compiler: BASCOM-AVR 2.0.5.0                                                *
'* Creation Date: 28.May.2011                                                  *
'* Last - Change: 06-Jun-2011                                                  *
'* Author: Behnam Zakizadeh, yazdkit.com, internet forum, Reza sepasYar(avr.ir)*
'* License: freeware                                                           *
'* www.avr64.com, www.yazdkit.com(jdate code), www.avr.ir(jdate code)          *
'* Ver: 1.1                                                                    *
'*******************************************************************************

$regfile = "m8def.dat"
$crystal = 1000000
$framesize = 128
$hwstack = 128
$swstack = 128
$projecttime = 32
$lib "ds1307clock.lib"

'Globals
Dim Weekday As Byte , Isleapyear As Bit , Isleapyearp As Bit
Dim Jmonth_a(12) As Byte , Gmonth_a(12) As Byte

'Int
Enable Interrupts

'DS1307 Pins
Config Sda = Portb.0 : Config Scl = Portb.1

'Address of DS1307
Const Ds1307w = &HD0 : Const Ds1307r = &HD1

'Clock init
Config Clock = User
Config Date = Mdy , Separator = /

'LCD
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = _
 Portc.5 , E = Portc.1 , Rs = Portc.0
Config Lcd = 16 * 2

'Keypad
Config Kbd = Portd

'Sub's
Declare Sub Init()
Declare Sub Main()
Declare Sub Task1()
Declare Sub Show()
Declare Function Jdate(byval Gdate As String) As String

'Backlight
Config Pinb.2 = Output : Backlight Alias Portb.2

'Speaker
Config Pinb.6 = Output : Speaker Alias Portb.6

'Main Prog Start Here:
Call Init()
Do
   Call Main()
Loop
End
'_______________________________________________________________________________

'Keypad Decode Data Table
Keypad:
Data "1" , "2" , "3" , "Esc"
Data "4" , "5" , "6" , "F2"
Data "7" , "8" , "9" , "F3"
Data "*" , "0" , "#" , "Enter" , "no"
'_______________________________________________________________________________

Sub Init()
   Cls : Cursor Off Noblink
   Set Backlight
   Sound Speaker , 240 , 50
   Lcd "     AMC-8"
   Lowerline
   Lcd " www.avr64.com"
   Wait 1
End Sub
'_______________________________________________________________________________

Sub Main()
   Cls : Cursor Off Noblink
   Call Task1()
   'other task here...
End Sub
'_______________________________________________________________________________

Sub Task1()
   Local _key As Byte
   Local _num As String * 5
   Cls
   Do
      Call Show()
      _key = Getkbd()
      _num = Lookupstr(_key , Keypad)

      If _num = "1" Then
         Incr _hour
         If _hour > 23 Then _hour = 0
         'when use (Time$ = str) to set data, the sub
         'settime automatically called. else if you want to change _hour,
         '_min and _sec you must call settime manually after change the var's.
         Gosub Settime
         Call Show()
         Sound Speaker , 120 , 20
         Waitms 200
      End If

      If _num = "2" Then
         Incr _min
         If _min > 59 Then _min = 0
         Gosub Settime
         Call Show()
         Sound Speaker , 120 , 20
         Waitms 200
      End If

      'Reset Date and Time (first usage and every time change backup battery)
      If _num = "Esc" Then
         'Date format is MM/DD/YY
         Date$ = "06/06/11"
         Time$ = "14:09:00"
         Call Show()
         Sound Speaker , 120 , 20
         Waitms 200
      End If
   Loop
End Sub
'_______________________________________________________________________________

Sub Show()
   Home : Lcd Time$
   Locate 1 , 11 : Lcd "Tehran"
   Lowerline
   Lcd Jdate(date$)
End Sub
'_______________________________________________________________________________

Function Jdate(byval Gdate As String) As String
   'Local Var's
   Local Tmp As String * 4 , Tmp1 As String * 10
   Local Jday As Integer , Jmonth As Integer , Jyear As Integer
   Local Gyear As Integer , Gmonth As Integer , Gday As Integer
   Local Gdayofyear As Integer , Gyear_ As Integer , Jdayofyear As Integer
   Local Gnumdayofyear As Integer , Iloop As Byte , Temp1 As Integer
   Local Temp2 As Integer , Temp3 As Integer , Temp4 As Integer
   Gdayofyear = 0 : Gyear_ = 0 : Jday = 0 : Jmonth = 0 : Jyear = 0
   Jdayofyear = 0 : Gnumdayofyear = 0 : Isleapyear = 0 : Isleapyearp = 0
   Iloop = 0 : Temp1 = 0 : Temp2 = 0 : Temp3 = 0 : Temp4 = 0
   Gmonth_a(1) = 31 : Gmonth_a(2) = 28 : Gmonth_a(3) = 31 : Gmonth_a(4) = 30
   Gmonth_a(5) = 31 : Gmonth_a(6) = 30 : Gmonth_a(7) = 31 : Gmonth_a(8) = 31
   Gmonth_a(9) = 30 : Gmonth_a(10) = 31 : Gmonth_a(11) = 30 : Gmonth_a(12) = 31
   Gnumdayofyear = 365

   'Calculate
   Tmp = Mid(date$ , 7 , 2)
   Gyear = Val(tmp) + 2000

   Tmp = Mid(date$ , 1 , 2)
   Gmonth = Val(tmp)

   Tmp = Mid(date$ , 4 , 2)
   Gday = Val(tmp)

   Temp1 = Gyear Mod 4 : Temp2 = Gyear Mod 100
   Temp3 = Gyear Mod 400 : Temp4 = Temp1 And Temp2
   If Temp4 <> 0 Or Temp3 = 0 Then
      Gmonth_a(2) = 28
   Else
      Gmonth_a(2) = 29
   End If
   Gyear_ = Gyear - 1
   Temp1 = Gyear_ Mod 4
   Temp2 = Gyear_ Mod 100
   Temp3 = Gyear_ Mod 400
   Temp4 = Temp1 And Temp2
   If Temp4 <> 0 Or Temp3 = 0 Then
     Reset Isleapyearp
   Else
     Set Isleapyearp
   End If
   Temp1 = Gmonth - 1
   For Iloop = 1 To Temp1
      Gdayofyear = Gmonth_a(iloop) + Gdayofyear
   Next
   Gdayofyear = Gday + Gdayofyear
   If Gdayofyear > 79 Then
      Temp1 = Gdayofyear - 79
      Jyear = Gyear - 621
      If Temp1 < 186 Then
      Temp2 = Temp1 Mod 31
      Temp3 = Temp1 / 31
         If Temp2 = 0 Then
            Jmonth = Temp3
            Jday = 31
         Else
            Jmonth = Temp3 + 1
            Jday = Temp2
         End If
      Else
         Temp2 = Temp1 - 186
         Temp3 = Temp2 Mod 30
         Temp4 = Temp2 / 30
         If Temp3 = 0 Then
            Jmonth = Temp4 + 6
            Jday = 30
         Else
            Jmonth = Temp4 + 7
            Jday = Temp3
         End If
       End If
   Else
      Jyear = Gyear - 622
      If Isleapyearp = 1 Then
         Gdayofyear = Gdayofyear + 11
      Else
         Gdayofyear = Gdayofyear + 10
      End If
      Temp2 = Gdayofyear Mod 30
      Temp3 = Gdayofyear / 30
      If Temp2 = 0 Then
         Jmonth = Temp3 + 9
         Jday = 30
      Else
         Jmonth = Temp3 + 10
         Jday = Temp2
      End If
   End If
   Tmp1 = ""
   Tmp = Str(jyear)
   Tmp1 = Tmp1 + Tmp
   Tmp1 = Tmp1 + "/"
   Tmp = Str(jmonth)
   Tmp = Format(tmp , "00")
   Tmp1 = Tmp1 + Tmp
   Tmp1 = Tmp1 + "/"
   Tmp = Str(jday)
   Tmp = Format(tmp , "00")
   Jdate = Tmp1 + Tmp
End Function
'_______________________________________________________________________________

'called from ds1307clock.lib
'Whan use Time$ and Date$ this sub's called from DS Lib to Set and Get your data
Getdatetime:
  I2cstart : I2cwbyte Ds1307w : I2cwbyte 0 : I2cstart : I2cwbyte Ds1307r
  I2crbyte _sec , Ack : I2crbyte _min , Ack : I2crbyte _hour , Ack
  I2crbyte Weekday , Ack : I2crbyte _day , Ack : I2crbyte _month , Ack
  I2crbyte _year , Nack : I2cstop
  _sec = Makedec(_sec) : _min = Makedec(_min) : _hour = Makedec(_hour)
  _day = Makedec(_day) : _month = Makedec(_month) : _year = Makedec(_year)
Return

Setdate:
  _day = Makebcd(_day) : _month = Makebcd(_month) : _year = Makebcd(_year)
  I2cstart : I2cwbyte Ds1307w : I2cwbyte 4 : I2cwbyte _day
  I2cwbyte _month : I2cwbyte _year : I2cstop
Return

Settime:
  _sec = Makebcd(_sec) : _min = Makebcd(_min) : _hour = Makebcd(_hour)
  I2cstart : I2cwbyte Ds1307w : I2cwbyte 0 : I2cwbyte _sec : I2cwbyte _min
  I2cwbyte _hour : I2cstop
Return
'_______________________________________________________________________________

'end of file